## Exerciții

>Pentru laboratorul acesta vom folosi scheletul oferit la adresa:
[lab3](https://gitlab.cs.pub.ro/pcom/pcom-laboratoare-public/-/tree/master/lab3). Tot
acolo se gaseste si un README.md cu functionalitatea disponibila. Pentru a face update la ultima
varianta a sheletului, folositi `git pull`.

Vom construi un protocol DataLink peste cel de data trecuta, astfel, avem deja
implementata functionalitatea de transmisie de cadre. Avem la dispozitie doua
servicii: `link_recv` si `link_send` ce se ocupa de framing si transmisia
cadrelor. Procolul nostru este **encapsulat** in payload-ul acelui protocol.
Vom considera un Maximum Transmission Unit (MTU) de 1500 bytes.

```
   |--------------------|
   |LEN|CHECKSUM|PAYLOAD|
   |--------------------|
     \    /
DELIM|PAYLOAD|DELIM -> Laboratorul trecut
```

**1\.** In funcția `simple_csum` din schelet, implementați algoritmul
de checksum asa cum a fost descris in laborator. Vom folosi structura
protocolului definita in `common.h`. Receptorul va afisa `Frame corrupted`
atunci cand detecteaza un cadru corupt. Vom folosi functia `htonl` pentru a trece valoarea pe care vrem o sa o scriem
in campul `sum` in `Network Order`. Invers, la receiver, vom folosi `ntohl` pentru
a trece in `Host Order`

---
**Note**

In scriptul `run_experiment.sh` avem campul `CORRUPTION` care manipuleaza rata
de corupere a pachetelor.

---

**2\.** Vom modifica implementarea precedenta pentru a folosi **CRC 32** in
loc de checksum. 

**3\.** Vom modifica protocolul pentru a realiza o **retransmisie simpla**.
Transmitatorul va trimite un cadru si va astepta un raspuns de la receptor.
Receptorul daca detecteaza un cadru corupt, va trimite un cadru prin care il va
informa pe transmitator de acest lucru (NACK), altfel, **va trimite o confirmare
(ACK)**. Este la latitudinea voastra de cum veti codifica cele doua tipuri de
raspunsuri. Vom testa implementarea prin trimiterea unui fisier in chunk-uri ce
nu depasesc dimensiunea maxima impusa de MTU.

> Pe link-ul nostru se strica doar 1 bit / cadru, putem astfel face codificaerea ACK/
NACK in asa fel incat daca este modificata, sa putem diferentia intre cele 2 tipuri de mesaje.
