# Procesul de forward (dirijiare)

Un router, pentru a trimite un pachet către următorul dispozitiv (**hop**) va
trebui să realizeze mai multe acțiuni (proces de forward). Procesul complet de
forwarding este următorul:

1.  Pe una dintre interfețe este recepționat un pachet IP.
2.  Verifică checksumul. Dacă acesta este greșit, aruncă pachetul
3.  Rulează algoritmul de **Longest Prefix Match (LPM)** în **tabela de rutare**
pentru a găsi următorul hop.
4.  În cazul în care nicio intrare din tabela nu face match, routerul aruncă
pachetul.
5.  Routerul decrementează câmpul TTL din header-ul IP. În cazul în care TTL
este 0, pachetul este aruncat.
6.  Recalcuelaza checksum-ul folosind formula incrementală descrisă anterior.
7.  Routerul face update la adresa MAC sursă a pachetului în adresa proprie
înainte de a îl trimite la următorul HOP și adresa MAC destinație a următorului
HOP.
8. Pachetul este trimis către următorul hop identificat prin LPM

Următorul slideshow prezintă acest proces:
<iframe class="is-fullwidth" height="600" marginheight="0" marginwidth="0" src="slides/forwarding.html">
</iframe>

Tabela de rutare este populată de algoritmii de routare (nu o să lucrăm cu ei la
PCom) și este structurată astfel:

```
Prefix          Next hop       Mask         Interface
192.168.0.0     192.168.0.2  255.255.255.0       0
192.168.1.0     192.168.1.2  255.255.255.0       1
192.168.2.0     192.168.2.2  255.255.255.0       2
192.168.3.0     192.168.3.2  255.255.255.0       3
```

Un dispozitiv are mai multe interfețe pe care poate trimite pachete (e.g. din
Londra, are una pentru Paris și una pentru Berlin).

